> ## Documentation Index
> Fetch the complete documentation index at: https://hoopdev-docs-improve-idp-sso-pages.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create User

> Creating a user will pre configure user definitions like display name, profile picture, groups and the slack id



## OpenAPI

````yaml https://use.hoop.dev/api/openapiv3.json post /users
openapi: 3.0.3
info:
  contact:
    email: help@hoop.dev
    name: Help
    url: https://help.hoop.dev
  description: >-
    Hoop.dev is an access gateway for databases and servers with an API for
    packet manipulation
  license:
    name: MIT
    url: https://opensource.org/license/mit
  termsOfService: https://hoop.dev/docs/legal/tos
  title: Hoop Api
  version: 1.49.10
servers:
  - url: https://use.hoop.dev/api
security: []
tags:
  - description: >
      Hoop implements Oauth2 and OIDC protocol to authenticate users in the
      system. To obtain a valid access token users need to authenticate in their
      own identity provider which is generated as a JSON response to the
      endpoint `http(s)://use.hoop.dev/api/login`. The identity provider them
      redirects the user to the callback endpoint containing the access token.


      The recommended approach of obtaining an access token is by visiting the
      Webapp main's page or using the **Hoop command line**. Example:


      ```sh

      hoop config create --api-url https://use.hoop.dev

      # save the token after authenticating at $HOME/.hoop/config.toml

      hoop login

      # show token information

      hoop config view --raw

      ```


      With an access token you could use any HTTP client to interact with the
      documented endpoints.

      The token must be sent through the `Authorization` header.


      Example:


      ```sh

      # obtain the current configuration of the server

      curl https://use.hoop.dev/api/serverinfo -H "Authorization: Bearer
      $ACCESS_TOKEN"

      ```
    name: Authentication
  - description: >
      Users are active and assigned to the default organization when they
      signup. A user could be set to an inactive state preventing it from
      accessing the platform, however it’s recommended to manage the state of
      users in the identity provider.


      - The `sub` claim is used as the main identifier of the user in the
      platform.

      - The profile of the user is derived from the id_token claims `email` and
      `name`.


      When a user authenticates for the first time, it performs an automatic
      signup that persist the profile claims along with it’s unique identifier.

      ​

      ### Groups


      Groups allows defining who may access or interact with certain resources.


      - For connection resources it’s possible to define which groups has access
      to a specific connection, this is enforced when the Access Control feature
      is enabled.

      - For review resources, it’s possible to define which groups are allowed
      to approve an execution, this is enforced when the Review feature is
      enabled.


      > This resource could be managed manually via Webapp or propagated by the
      identity provider via ID Token. In this mode, groups are sync when a user
      performs a login.


      ### Roles


      - The `admin` group is a special role that grants full access to all
      resources


      This role should be granted to users that are responsible for managing the
      Gateway. All other users are regular, meaning that they can access their
      own resources and interact with connections.
    name: User Management
  - description: Routes used to manage and obtain information about the runtime server.
    name: Server Management
  - description: Features available in the gateway. See also **Plugin** resources.
    name: Features
  - description: >-
      Proxy manager endpoints controls how clients connect via gRPC in the
      gateway. These endpoints are meant to be used when a client is initialized
      via `hoop proxy-manager`.
    name: Proxy Manager
  - name: Connections
  - name: Agents
  - name: Runbooks
  - name: Guard Rails
  - name: Reviews
  - name: Sessions
  - name: Organization Management
  - name: Reports
paths:
  /users:
    post:
      tags:
        - User Management
      summary: Create User
      description: >-
        Creating a user will pre configure user definitions like display name,
        profile picture, groups and the slack id
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/openapi.User'
        description: The request body resource
        required: true
        x-originalParamName: request
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.User'
          description: Created
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Bad Request
        '409':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Conflict
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Unprocessable Entity
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Internal Server Error
components:
  schemas:
    openapi.User:
      properties:
        email:
          description: Email address of the user
          format: email
          type: string
        groups:
          description: Groups registered for this user
          example:
            - sre
            - dba
          items:
            type: string
          type: array
        id:
          description: Unique identifier of the resource
          format: uuid
          readOnly: true
          type: string
        name:
          description: Display name
          example: John Wick
          type: string
        password:
          description: Local auth cases have a password
          example: mysecurepassword
          type: string
        picture:
          description: The profile picture url to display
          example: ''
          type: string
        role:
          description: >-
            Permission related to the user

            * admin - Has super privileges and has access to any resource in the
            system

            * standard - Grant access to standard routes.

            * unregistered - Grant access to unregistered routes. It's a
            transient state where the user is authenticated but is not
            registered.

            This state is only available for multi tenant environments
          enum:
            - admin
            - standard
            - unregistered
          example: standard
          readOnly: true
          type: string
        slack_id:
          description: The identifier of slack to send messages to users
          example: U053ELZHB53
          type: string
        status:
          allOf:
            - $ref: '#/components/schemas/openapi.StatusType'
          default: active
          description: The status of the user. Inactive users cannot access the system
        verified:
          description: DEPRECATED in flavor of role
          readOnly: true
          type: boolean
      required:
        - email
      type: object
    openapi.HTTPError:
      properties:
        message:
          example: the error description
          type: string
      type: object
    openapi.StatusType:
      enum:
        - active
        - inactive
        - invited
      type: string

````